/*
    FEARLUS model0-6-2: Coordinate2DList.m
    Copyright (C) 1999-2002  Macaulay Institute
    Copyright (C) 1999-2002  Macaulay Institute
    Copyright (C) 1999-2002  Macaulay Institute

    This file is part of FEARLUS model0-6-2, an agent-based model of land use
    change.

    FEARLUS model0-6-2 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-6-2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/


#import "Coordinate2DList.h"
#import "Coordinate2D.h"

@implementation Coordinate2DList

+create: aZone {
  Coordinate2DList *obj;

  obj = [super create: aZone];
  obj->clist = [List create: aZone];

  return obj;
}

-(void)addTail: (Coordinate2D *)c {
  [clist addLast: c];
}

-(void)addHead: (Coordinate2D *)c {
  [clist addFirst: c];
}

-(Coordinate2D *)removeHead {
  return (Coordinate2D *)[clist removeFirst];
}

-(Coordinate2D *)removeTail {
  return (Coordinate2D *)[clist removeLast];
}

-begin: aZone {
  return [clist begin: aZone];
}

-(BOOL)member: (Coordinate2D *)c {
  id i;
  Coordinate2D *cm;

  for(i = [clist begin: scratchZone], cm = (Coordinate2D *)[i next];
      [i getLoc] == Member;
      cm = (Coordinate2D *)[i next]) {
    if(cm->x == c->x && cm->y == c->y) {
      [i drop];
      return YES;
    }
  }
  [i drop];
  return NO;
}

-(void)removeAll {
  [clist removeAll];
}

-(void)deleteAll {
  [clist deleteAll];
}

-print {
  id i;
  Coordinate2D *cm;

  printf("[ ");
  for(i = [clist begin: scratchZone], cm = (Coordinate2D *)[i next];
      [i getLoc] == Member;
      cm = (Coordinate2D *)[i next]) {
    printf("(%d, %d) ", cm->x, cm->y);
  }
  printf("]\n");
  [i drop];
  return self;
}

-(void)drop {
  [clist drop];
  [super drop];
}


@end
